/*
 *  Copyright (C) 2008, Pedro Carlos da Silva Lara
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version. 
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.   
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package ec;

import java.math.BigInteger;
import java.util.HashMap;

public class NAF {
	public static int mods2w(BigInteger K, byte  w ) {
        int res = K.mod( new BigInteger( (1 << w) + "" ) ).intValue();
        if( res >  (1 << (w - 1 ) ) ) {
            return res - (1 << w );
        } else {
            return res;
        }
    }
    
    public static HashMap<Integer, ec.gf.Point> PreComputingNAF2w( ec.gf.Point P, byte w ) {
    	HashMap<Integer, ec.gf.Point> ret = new HashMap<Integer, ec.gf.Point>();
    	for(int i = 1; i <=((1 << (w-1)) -1); i+=2) {
    		ret.put( i, P.multiply( new BigInteger(i +"")));
    	}
    	
    	return ret;
    }
    
    public static HashMap<Integer, ec.zp.Point> PreComputingNAF2w( ec.zp.Point P, byte w ) {
    	HashMap<Integer, ec.zp.Point> ret = new HashMap<Integer, ec.zp.Point>();
    	for(int i = 1; i <=((1 << (w-1)) -1); i+=2) {
    		ret.put( i, (P).multiply( new BigInteger(i +"")) );
    	}
    	
    	return ret;
    }
}
