/*
 *  Copyright (C) 2008, Pedro Carlos da Silva Lara
 *	
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version. 
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.   
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package ec.gf;

import java.math.BigInteger;

public class Utils {
	public static int[] toIntArray(BigInteger x) {
        byte[] val = x.toByteArray();
        int[] p = new int[(val.length + 3)/4]; 
        int t = 0, i;
        for (i = val.length; i >= 4; i -= 4) {
            p[t++] = (val[i - 1] & 0xff) ^
                    ((val[i - 2] & 0xff) <<  8) ^
                    ((val[i - 3] & 0xff) << 16) ^
                    ((val[i - 4] & 0xff) << 24);
        }
        switch (i) {
	        case 3:
	            p[t++] = (val[2] & 0xff) ^
	                    ((val[1] & 0xff) <<  8) ^
	                    ((val[0] & 0xff) << 16);
	            break;
	        case 2:
	            p[t++] = (val[1] & 0xff) ^
	                    ((val[0] & 0xff) <<  8);
	            break;
	        case 1:
	            p[t++] = (val[0] & 0xff);
	            break;
	        case 0:
	            break;
        }
        return p;
    }

	public static BigInteger toBigInteger(int[] p) {
        byte[] w = new byte[1 + 4*p.length];
        w[0] = 0;
        int t = 1;
        for (int i = p.length - 1; i >= 0; i--) {
            int z = p[i];
            w[t++] = (byte)(z >>> 24);
            w[t++] = (byte)(z >>> 16);
            w[t++] = (byte)(z >>>  8);
            w[t++] = (byte)(z);
        }
        return new BigInteger( w );
    }
    
	public static int [] shiftLeft( int [] v, int n ) {
		BigInteger Aux = toBigInteger( v );
		return toIntArray( Aux.shiftLeft(n) );
	}
	
	public static int [] shiftRight( int [] v, int n ) {
		BigInteger Aux = toBigInteger( v );
		return toIntArray( Aux.shiftRight( n ) );
	}
	
	public static int [] truncate(int [] v, int j ){
		int n = v.length - j;
		int [] ret = new int[n];
		
		for(int i = 0 ; i < n; i++)
				ret[i] = v[i + j];
		return ret; 
	}
	
	
}
