/*
 *  Copyright (C) 2008, Pedro Carlos da Silva Lara
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version. 
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.   
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package ec.zp;

import java.math.BigInteger;
import java.util.HashMap;

public class Utils {
    
    public static int [] NAF(BigInteger K, byte w) {
        int [] k = new int[K.bitLength() + 1];
        for( int i = 0; K.compareTo( BigInteger.ONE ) >= 0; i++ ) {
            if( K.testBit( 0 ) ) {
                k[i] = mods2w(K, w);
                K = K.subtract( new BigInteger( k[i] + "" ) );
            } else {
                k[i] = 0;
            }
            
            K = K.shiftRight( 1 );
        }
        return k;
    }
    
    public static int mods2w(BigInteger K, byte  w ) {
        int res = K.mod( new BigInteger( (1 << w) + "" ) ).intValue();
        if( res >  (1 << (w - 1 ) ) ) {
            return res - (1 << w );
        } else {
            return res;
        }
    }
    
    public static HashMap<Integer, Point> PreComputingNAF2w( Point P, byte w ) {
    	HashMap<Integer, Point> ret = new HashMap<Integer, Point>();
    	for(int i = 1; i <=((1 << (w-1)) -1); i+=2) {
    		ret.put( i, P.multiply( new BigInteger(i +"")));
    	}
    	
    	return ret;
    }
    
    public static String getString(int [] k ) {
        String ret = new String("");
        for (int i = 0; i <k.length; i++) {
            ret += k.toString();
        }
        return ret;
    }
    
    
}
